/* Simple Table Sorter v1.2 (http://ir2.ru/dhtml6table.aspx) */
/* @require http://ir2.ru/ir2.js 19.08.2010 */
/* Использование: 
требуется правило CSS: .i {font-style:italic;} 
1) подключить (через эл-т HEAD) к странице два скрипта 
 (библиотеку http://ir2.ru/ir2.js и этот);
2) сортируемым таблицам (тэгам TABLE) добавить class='sortable' 
 (можно через пробел: class='big superborder sortable');
3) в строке заголовка (при щелчке по которому происходит сортировка) 
 должны быть элементы TH (а не TD);
4) вводится 3 типа данных (str не вводится - он по умолчанию) 
 для сотрировки: num|datru|daten, их следует вписывать в ячейку 
 заголовка как атрибут: <th axis="num">;
5) пользователь может сам определять тип сортировки:
 щелчок с удержанным Shift - Number,
 щелчок с удержанным Ctrl - Date (RU),
 щелчок с удержанным Ctrl+Alt - Date (EN)
6) можно при сортировке добавлять к заголовкам ячеек 
title "Отсортировано по...", если указать в в секции 
"настройки" use_title = true;
7) можно сохранять состояние сортировки для каждой 
таблицы (в cookie), для этого в секции "настройки"
нужно указать use_cookie = true;
8) удалить куки для данной таблицы (сбросить сохранённое
состояние сортировки) можно щелчком по заголовку
с удержанными клавишами Ctrl+Alt+Shift
*/

/* настройки */
 /* использование всплывающего title */
var use_title = true /* added by Clusta */
 /* сохранение-восстановление предыдущей сортировки */
var use_cookie = true
/* настройки конец */

function scells(row) {
 var sarr=[], cells=row.cells;
 for (var i=0; i<cells.length; i++) {
  var c=striptags(cells[i].innerHTML).toLowerCase();
  sarr[i]=c;
 }
 return sarr;
}
addLoadEvent(preptabs);
function preptabs() {
 window.verse=false;
 var uri=location.pathname
 var tex=document.getElementsByTagName("TABLE");
 for (var el=0; el<tex.length; el++) { /*Поиск таблиц и назначение onclick*/
  var elem=tex[el];
  if (1==elem.nodeType && "TABLE"==elem.tagName && / *sortable\b/i.test(elem.className)) {
   elem.sorted=NaN;
   elem.rarr=[el];
   if (use_cookie) {
   /* восттановление предыдущей сортировки */
    
    elem.cookid=new Array(uri+"_tab"+el, "");
    var task=getCookie(elem.cookid[0])
    if (task) {
     var taskarr, cellid
     task=task.split(",")
     for (var i=0; i<task.length; i++) {
      if (task[i]) {
       taskarr=task[i].split(":")
       if (!isNaN(parseInt(taskarr[0]))) {
        cellid=Math.abs(parseInt(taskarr[0]))
        sorttab(elem.rows[0].cells[cellid], elem.rows[0], taskarr[1])
       }
      }
     }
    }
   /* восттановление предыдущей сортировки конец */
   }
   elem.rows[0].onclick=clicktab;
   elem.rows[0].style.cursor="pointer";
/*
   var th=elem.rows[0].cells;
   for(var jj=0; jj<th.length; jj++) {
    th[jj].title="Сортировать по столбцу \""+striptags(th[jj].innerHTML)+"\"";
	th[jj].rel="norm";
   }
*/
   if (use_title) elem.rows[0].title = "Сортировать"
   for (var j=1; j<elem.rows.length; j++) {
    /*Если таблица одна, можно запомнить-восстановить статус
    rarr[j]={val:elem.rows[j], sortcells:scells(elem.rows[j])}; 
    затем сортировать по списку колонок из куки */
    if (0==j%2) elem.rows[j].style.backgroundColor="#f0f0f0";
    elem.rows[j].onmouseover=overtab; /*"Зебра" и подсветка*/
    elem.rows[j].onmouseout=overtab;
   }
  }
 }
}

var trcolor, overcolor="#ccf";
function overtab(e) {
 e = e || window.event;
 var obj=e.target || e.srcElement;
 var tr=obj.parentNode;
 if (overcolor==tr.style.backgroundColor) {
  tr.style.backgroundColor=trcolor;
 } 
 else {
  trcolor=tr.style.backgroundColor;
  tr.style.backgroundColor=overcolor;
  /*тупой перевод в формат rgb()*/
  overcolor=tr.style.backgroundColor; 
 }
}

function clicktab(e) {
 e = e || window.event;
 prevent(e);
 var sorttype=false;
 if (!e.ctrlKey && e.shiftKey && !e.altKey) sorttype="num";
 if (e.ctrlKey && !e.shiftKey && e.altKey) sorttype="daten";
 if (e.ctrlKey && !e.shiftKey && !e.altKey) sorttype="datru";
 var obj=e.target || e.srcElement;
 /* Если в заголовке сложный код */
 if ("TH"!=obj.tagName && "TD"!=obj.tagName) {
  var testobj=findParent(obj, "TH"); //ячейка заголовка
  if (!testobj) { / * обратная совместимость (с TD в заголовке) */
   testobj=findParent(obj, "TD");
   if (this!=testobj.parentNode) testobj=null;
  }
  obj=testobj;
 }
 if (!obj) return;
 if (e.ctrlKey && e.shiftKey && e.altKey) {
  var t=findParent(obj, "TABLE", "sortable");
  if (!t || "object"!=typeof t.cookid) return;
  setCookie(t.cookid[0], "", "", -1) //delete cookie
//  alert(document.cookie)
  location.reload();
  return;
 }
 sorttab(obj, this, sorttype) /* Параметры: ячейка, строка заголовка, тип сортировки */
}

function sorttab(obj, row0, sorttype) {
 var d1=new Date(); //измерять скорость
 if (!sorttype) {
  sorttype=obj && obj.axis;
  sorttype = (sorttype) ? 
   /str|num|datru|daten/i.exec(sorttype)[0] : "str";
 }
/* this - TR[0] */
 var table=findParent(obj, "TABLE"); //таблица
 var i=obj.cellIndex; /*номер сортируемой колонки*/
/* стрелки */
 addclass(obj, "i") /* требуется правило CSS: .i {font-style:italic;} */
 var otext=obj.innerHTML, ol=otext.length
 if (8595==otext.charCodeAt(ol-1)) {
  obj.innerHTML=otext.replace(/ .$/i, " &uarr;")
  if (use_title) obj.title="Отсортировано по убыванию"
  if (use_cookie && "object"==typeof table.cookid) table.cookid[1]+=","+(-i)+":"+sorttype
 }
 else if (8593==otext.charCodeAt(ol-1)) {
  obj.innerHTML=otext.replace(/ .$/i, " &darr;")
  if (use_title) obj.title="Отсортировано по возрастанию"
  if (use_cookie && "object"==typeof table.cookid) table.cookid[1]+=","+i+":"+sorttype
 }
 else {
  obj.innerHTML+=" &darr;"
  if (use_title) obj.title="Отсортировано по возрастанию"
  if (use_cookie && "object"==typeof table.cookid) table.cookid[1]+=","+i+":"+sorttype
 }
 /* удаление предыдущих стрелок */
 if (!isNaN(table.sorted) && table.sorted!=i) {
  var oldotext=row0.cells[table.sorted].innerHTML
  row0.cells[table.sorted].innerHTML=oldotext.substr(0, oldotext.length-2)
 }
 /* удаление предыдущих стрелок конец */
/* стрелки конец */
 if (use_cookie && "object"==typeof table.cookid) {
  var tocut=new RegExp(i+"\\:"+sorttype+"\\,\\-"+i+"\\:"+sorttype+"\\,"+i+"\\:"+sorttype)
  table.cookid[1]=table.cookid[1].replace(tocut, i+":"+sorttype)
//  alert(table.cookid[1])
  setCookie(table.cookid[0], table.cookid[1], "", 0)
 }
 var tbody=table.lastChild; /*TBODY - в нём лежат строки*/
 if (i==table.sorted && sorttype==table.sorttype && "object"==typeof table.rarr) { /*сортировка*/
  table.rarr=table.rarr.reverse();
 }
 else {
  if ("object"!=typeof table.rarr) table.rarr=[]
  for (var j=1; j<table.rows.length; j++) {
  /*создание массива строк таблицы и определение типа сортировки*/
   var c=table.rows[j] && table.rows[j].cells[i];
//   table.rows[j].cells[0].innerHTML+="'"+j
   /*ячейки может не быть в кривой таблице*/
   var cval=(c)?c.innerHTML:"";
   /* "Универсальный" массив, лишний тормоз при объёме
   rarr[j]={val:table.rows[j], sortcells:scells(table.rows[j])}; */
   var tmp, newval=0, sortcell=striptags(cval).toLowerCase();
   switch (sorttype) {
    case "datru":
     tmp=sortcell.split("."); 
     for (var x=tmp.length-1; x>=0; x--) {
      newval+=parseInt(tmp[x]) * Math.pow(100, x)
     }
     sortcell = (isNaN(newval)) ? Infinity : newval; 
     break
    case "daten":
     tmp=sortcell.split(/\.|\//); 
     if (tmp[2]) newval+=parseInt(tmp[2]) * Math.pow(100, 2);
     if (tmp[0]) newval+=parseInt(tmp[0]) * Math.pow(100, 1);
     if (tmp[1]) newval+=parseInt(tmp[1]);
     sortcell = (isNaN(newval)) ? Infinity : newval; 
     break
    case "num":
     sortcell = Number(sortcell);
     sortcell = (isNaN(sortcell)) ? Infinity : sortcell; 
     break
    default:
     sortcell=String(sortcell)
     break
   }
   table.sorttype=sorttype;
   table.rarr[j-1]={val:table.rows[j], sortcell:sortcell};
   //table.deleteRow(j); /*Не нужно!*/
  } /*создание массива конец*/
  table.rarr=table.rarr.sort(cmprow);
 } 
 table.sorted=i; /*сортировка конец*/
 /*добавить строки отсортированного массива в таблицу*/
 for (var l=0; l<table.rarr.length; l++) {
  if (table.rarr[l] && table.rarr[l].val) {
   if (l%2) table.rarr[l].val.style.backgroundColor="f0f0f0";
   else table.rarr[l].val.style.backgroundColor="fff";
   tbody.appendChild(table.rarr[l].val);
  }
  //строка добавляется в таблицу, удаляясь из той же таблицы
  //(массив rarr - только упорядоченные ссылки на строки)
 }
 
 /*var d3=new Date(); alert(d3-d1); d1=d3; //раскомментировать для учёта времени*/
}

function cmprow(a, b) {
 a=a.sortcell, b=b.sortcell;
 try { 
  /* verse нужно, если восстановливать сорт. из куки 
   - на практике это оказалось не так */
  if (a > b) return (verse)?-1:1;
  if (a < b) return (verse)?1:-1;
 }
 catch(e){return 0;}
 return 0;
}